# 基本准则

* **遵循 [接入文档](https://github.com/wequick/Small/blob/master/Android/README.md).** 或按照 [示例程序](https://github.com/wequick/Small/blob/master/Android/Sample) 来进行你的项目重构与接入.
* **理解 [项目结构](https://github.com/wequick/Small/issues/207)**. 接入Small更多的工作是在模块拆分上，理解结构将减少不必要的麻烦。
* **在创建新issue前先搜索 [已有的issues](https://github.com/wequick/Small/issues).** 在已有的issue上补充你发现的有助于解决问题的新信息.
* **只创建跟Small框架有关的issue.** 如果问题是“怎么实现...”, 请查阅我们的 [WIKI](https://github.com/wequick/Small/wiki)(包括里面的FAQ) 或到我们的QQ群上提问.
* **保持issue简洁有效.** 提供所有有助于解决问题的系统环境, 不要含混无关的细节. 一个好的issue应该能够让我们更快地解决它而非讨论它.
* **及时跟踪反馈你的issue.** 及时的反馈将有助于我们更快的修复它并且发布到新的版本里.
* **使用 [Markdown语法](https://help.github.com/articles/markdown-basics/).** 把代码块与日志输出放到反引号区间里 (```` ``` ````). 这将增加可读性，标记上语言更好. (注: gradle-small使用groovy语言.)
* **不要灌水.** 尽可能多地提供有用的信息，不要简单地 +1. 不要评论无关Small的issue.

## 提bug

简而言之, 大家都是开发者, 请提出 _你自己_ _希望收到的_ bug.

我们 **不是** 为你的个人项目服务. 我们依赖 _你_ (你的团队)
的贡献以使得我们的框架更好地服务于大家. 在创建issue前请充分调试并排除自己的bug，并告知你所有尝试过的解决方法跟对应的结果.
如果无法准确地复现问题，将很难跟进。

首先请确认你已经使用了 [最新](https://bintray.com/galenlin) 的 `Small版本`.
或者查看更新日志来确认问题是否已在新版本中解决。

- [gradle-small CHANGELOG](https://github.com/wequick/Small/blob/master/Android/DevSample/buildSrc/CHANGELOG.md)
- [small CHANGELOG](https://github.com/wequick/Small/blob/master/Android/DevSample/small/CHANGELOG.md)

再确认同样的问题可以在 [示例程序](https://github.com/wequick/Small/blob/master/Android/Sample) 里复现.

请提供复现问题的步骤以及 _所有_ 其它相关的信息, 包括gradle-small版本、small版本、Android Gradle Plugin版本等.
可以通过 `$ ./gradlew small` 命令来打印一些有用的数据。

如果没有按照规范来提问并且没有进一步的跟进，问题将被认定为无效并关闭。

如果是编译阶段出现的错误，请贴出使用 `--stacktrace` 参数来打印更多的堆栈错误。
请确认堆栈中包含了 `net.wequick.gradle` 包名下的错误，如果没有请先谷歌搜索你的错误信息。

```
$ ./gradlew buildLib --stacktrace
```

如果你已经熟悉了Github，在你的fork分支上构造一个引发错误的用例将有助于加快bug的解决。

## 提功能需求

请尽量精确地给出该功能的预期结果，以及这个功能对现有功能的影响。

> 根据二八原则，请提出能够正向影响到80%使用者的需求。

## 提交代码

我们欢迎大家提PR，并将合并有意义的提交。
更多提交代码的流程与规范，建议先阅读下 [开源贡献指南](https://guides.github.com/activities/contributing-to-open-source)。

所有的贡献 _将_ 遵循 Apache 2.0 开源协议.

## 规范要求

如果你已经认真阅读了本指南并同意本指南，请使用我们的 [模板](https://raw.githubusercontent.com/wequick/Small/master/issue%E6%A8%A1%E6%9D%BF.md) 来创建issue。
看起来应该是[这样的](https://github.com/wequick/Small/blob/master/issue模板.md)。
